function group = micca_full_connected_set(C,indx_sample,thresh)
%
% group = full_connected_set(C,indx_sample,thresh)
%

tmp = triu(C,1);
[pairs, I] = sort(abs(tmp(:)), 'descend');
[x y] = ind2sub(size(C),I);

i = 1;
nb_group = 0;
group = indx_sample*0;
while(sum(group == 0) > 0 && i<=length(pairs) && pairs(i) > thresh)
  % distance intra-sujet ?
  if(indx_sample(x(i)) == indx_sample(y(i)))
    i = i+1;
    continue
  end
  % Les deux composantes deja dans un groupe
  if(group(x(i)) ~= 0 && group(y(i)) ~= 0)
    i = i + 1;
    continue
  end
  % Une des composantes est deja dans un groupe ?
  if(group(x(i)) ~= 0)
    % indx_sample de la compo 'y' deja dans le groupe ?
    if(~ismember(indx_sample(y(i)), indx_sample(group == group(x(i)))))
      if(min(C(y(i), group == group(x(i)))) > thresh)
        group(y(i)) = group(x(i));
      end
    end
    i = i + 1;
    continue
  end
  if(group(y(i)) ~= 0)
    % indx_sample de la compo 'y' deja dans le groupe ?
    if(~ismember(indx_sample(x(i)), indx_sample(group == group(y(i)))))
      if(min(C(x(i), group == group(y(i)))) > thresh)
        group(x(i)) = group(y(i));
      end
    end      
    i = i + 1;
    continue
  end
  % Pas de groupe pour les deux
  if(group(x(i)) == 0 && group(y(i)) == 0)
      % Nouveau groupe
      nb_group = nb_group + 1;
      group(x(i)) = nb_group;
      group(y(i)) = nb_group;
  end
  i = i + 1;
  %hist(nonzeros(group),1:max(group))
  %drawnow
end

return